# A simple scope wrapper used during expression evaluation, so that
# the expressions don't have full access to the scope objects.
#
# @api private
module Puppet
  module Util
    class PePuppetdbScopeWrapper
      def initialize(scope)
        scope.to_hash.each do |name, value|
          realname = name.gsub(/[^\w]/, '_')
          instance_variable_set('@' << realname, value)
        end
      end

      def eval(expression)
        super
      end
    end
  end
end
